#include "minigui.ch"
*
*  HBTEST.PRG
*
*  Este ejemplo es para probar con Harbour en modo consola, sin FiveWin
*  para Harbour.
*
*  This example is done for testing with Harbour in console mode, without
*  FiveWin for Harbour.
*

#define CRLF Chr( 13 ) + Chr( 10 )

PROCEDURE MAIN()

   PRIVATE nOption := 1
   PRIVATE cVector := {}
   AADD( cVector , "Excel" )
   AADD( cVector , "Word" )
   AADD( cVector , "Internet Explorer" )
   AADD( cVector , "Outlook" )
   AADD( cVector , "Quit" )

   DEFINE WINDOW HbOle ;
          AT 0 , 0 ;
          WIDTH 440 ;
          HEIGHT 340 ;
          TITLE "HbOle Test" ;
          MAIN ;
          NOSYSMENU ;
          ON INIT FunLoop()

      @ 100 , 100 LABEL LWait ;
         VALUE 'Wait' ;
         WIDTH 275 ;
         FONT 'arial' SIZE 20 BOLD ;
         FONTCOLOR {0,0,255}

   END WINDOW

   CENTER WINDOW HbOle

   ACTIVATE WINDOW HbOle

Return .T.

Function FunLoop()

   While .t.

      nOption := US_Achoice( cVector , nOption , "Test hbole.lib with ..." )

      DO EVENTS

      IF nOption == 0
         EXIT
      ELSEIF nOption == 1
         EXCEL97()
      ELSEIF nOption == 2
         WORD97()
      ELSEIF nOption == 3
         IEXPLORER()
      ELSEIF nOption == 4
         OUTLOOK()
      ELSEIF nOption == 5
         EXIT
      ENDIF

   EndDo

   DoMethod( "HbOle" , "release" )

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE EXCEL97()

   LOCAL oExcel, oHoja

   oExcel := TOleAuto():New( "Excel.Application" )

   oExcel:WorkBooks:Add()

   oHoja := oExcel:ActiveSheet()

   oHoja:Cells:Font:Name := "Arial"
   oHoja:Cells:Font:Size := 12

   oHoja:Cells( 3, 1 ):Value := "Text:"
   oHoja:Cells( 3, 2 ):Value := "This is sample text"
   oHoja:Cells( 4, 1 ):Value := "Numeric:"
   oHoja:Cells( 4, 2 ):NumberFormat := "#.##0,00"
   oHoja:Cells( 4, 2 ):Value := 1234.50
   oHoja:Cells( 5, 1 ):Value := "Logical:"
   oHoja:Cells( 5, 2 ):Value := .T.
   oHoja:Cells( 6, 1 ):Value := "Date:"
   oHoja:Cells( 6, 2 ):Value := DATE()

   oHoja:Columns( 1 ):Font:Bold := .T.
   oHoja:Columns( 2 ):HorizontalAlignment := -4152  // xlRight

   oHoja:Columns( 1 ):AutoFit()
   oHoja:Columns( 2 ):AutoFit()

   oHoja:Cells( 1, 1 ):Value := "OLE in Harbour"
   oHoja:Cells( 1, 1 ):Font:Size := 16
   oHoja:Range( "A1:B1" ):HorizontalAlignment := 7

   oHoja:Cells( 1, 1 ):Select()
   oExcel:Visible := .T.

// ini CdQ Mod
// oHoja:End()
// oExcel:End()
#ifndef __XHARBOUR__
   oHoja:End()
   oExcel:End()
#else
// oExcel:Quit()
#endif
// end CdQ Mod

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE WORD97()

   LOCAL oWord, oTexto

   oWord:=TOleAuto():New( "Word.Application" )

   oWord:Documents:Add()

   oTexto := oWord:Selection()

   oTexto:Text := "Harbour hbOLE.lib"+CRLF+"Word Sample"+CRLF
   oTexto:Font:Name := "Arial"
   oTexto:Font:Size := 48
   oTexto:Font:Bold := .T.

   oWord:Visible := .T.
   oWord:WindowState := 1  // Maximize

   oTexto:End()
// ini CdQ Mod
// oWord:End()
#ifndef __XHARBOUR__
   oWord:End()
#endif
// end CdQ Mod

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE IEXPLORER()

   LOCAL oIE

   oIE:=TOleAuto():New( "InternetExplorer.Application" )

   oIE:Visible := .T.

   oIE:Navigate( "http://www.harbour-project.org" )

// ini CdQ Mod
// oIE:End()
#ifndef __XHARBOUR__
   oIE:End()
#endif
// end CdQ Mod

RETURN

//--------------------------------------------------------------------

STATIC PROCEDURE OUTLOOK()

   LOCAL oOL, oLista, oMail, i

   oOL := TOleAuto():New( "Outlook.Application.9" )

   IF Ole2TxtError() != "S_OK"

      Alert("Outlook is not available", "Error")

   ELSE

      oMail := oOL:CreateItem( 0 )  // olMailItem

      FOR i := 1 TO 10
         oMail:Recipients:Add( "Contact" + LTRIM( STR( i, 2 ) ) + ;
               "<contact" + LTRIM( STR( i, 2 ) ) + "@server.com>" )
      NEXT

      oLista := oOL:CreateItem( 7 )  // olDistributionListItem
      oLista:DLName := "Test with distribution list"
      oLista:Display( .F. )
      oLista:AddMembers( oMail:Recipients )
      oLista:Save()
      oLista:Close( 0 )

      oMail:End()
      oLista:End()
// ini CdQ Mod
//    oOL:End()
#ifndef __XHARBOUR__
      oOL:End()
#endif
// end CdQ Mod

   ENDIF

RETURN

// Function by Grigory Filatov
Function US_Achoice( aItems, nValue, cTitle )
   // DEFAULT cTitle TO "Please, select", nValue TO 0
   if( cTitle == NIL , cTitle := "Please, select" , )
   if( nValue == NIL , nValue := 0 , )
   DEFINE WINDOW US_AcoiceForm ;
      AT 0,0 ;
      WIDTH 400 HEIGHT 300 ;
      TITLE cTitle ;
      MODAL ;
      NOSYSMENU
      @ 235,190 BUTTON US_AcoiceOk ;
         CAPTION 'OK' ;
         ACTION {|| nValue := GetProperty( "US_AcoiceForm" , "US_AcoiceList" , "value" ) , US_AcoiceForm.Release } ;
         WIDTH 80
      @ 235,295 BUTTON US_AcoiceCancel ;
         CAPTION 'Cancel' ;
         ACTION {|| nValue := 0, US_AcoiceForm.Release } ;
         WIDTH 80
      @ 20,15 LISTBOX US_AcoiceList ;
         WIDTH 360 ;
         HEIGHT 200 ;
         ITEMS aItems ;
         VALUE nValue ;
         FONT "Ms Sans Serif" ;
         SIZE 12 ;
         ON DBLCLICK {|| nValue := GetProperty( "US_AcoiceForm" , "US_AcoiceList" , "value" ), US_AcoiceForm.Release }
   END WINDOW
   CENTER WINDOW US_AcoiceForm
   ACTIVATE WINDOW US_AcoiceForm
return nValue
